<ui:composition xmlns:g="http://www.ihe.net/gazelle"
                xmlns:h="http://java.sun.com/jsf/html"
                xmlns:f="http://java.sun.com/jsf/core"
                xmlns:a4j="http://richfaces.org/a4j"
                xmlns:ui="http://java.sun.com/jsf/facelets"
                xmlns:s="http://jboss.org/schema/seam/taglib"
                xmlns:rich="http://richfaces.org/rich"
                xmlns="http://www.w3.org/1999/xhtml" template="/layout/template.xhtml">
    <ui:define name="body">
        <ui:decorate template="_template.xhtml">
            <ui:param name="pageName" value="testStepCoverage"/>
            <ui:param name="controllerName" value="#{testStepLinkManager}"/>
            <ui:param name="tabId" value="menuTabs"/>
            <ui:param name="linkEntityFilterDivTitle"
                      value="#{messages['net.ihe.gazelle.assertion-manager.TestFilter']}"/>
            <ui:define name="linkEntityFilterDiv">
                <ui:include src="_testsFilters.xhtml">
                    <ui:param name="bean" value="#{testStepLinkManager}"/>
                    <ui:param name="refreshOnChange" value="testsForm,testStepsForm,idSchemesForm,description"/>
                </ui:include>
            </ui:define>
            <ui:define name="idSchemeFilterPanel">
                <ui:include src="_assertionsFilters.xhtml">
                    <ui:param name="filterParam" value="#{testStepLinkManager.filter}"/>
                    <ui:param name="idSchemeIdToRefresh" value="idSchemesForm,menuTabs"/>
                </ui:include>
            </ui:define>
            <ui:define name="linkingEntityFold">
                <div class="col-md-5">
                    <h:form id="testsForm">
                        <ui:decorate template="/layout/panels/_panel_title.xhtml">
                            <ui:define name="panel_title">#{testStepLinkManager.tests.size} filtered tests
                            </ui:define>
                            <rich:dataTable rows="20" id="TestStepIdTests" var="test"
                                            value="#{testStepLinkManager.tests}" render="TestStepIdTestsDs">
                                <g:column sortBy="#{'keyword'}">
                                    <ui:define name="header">
                                        #{messages['net.ihe.gazelle.assertion-manager.TestsAvailable']}
                                    </ui:define>
                                    <h:outputText value="#{test.keyword}"
                                                  style="#{testStepLinkManager.getSelectedTest().getId() == test.getId() ? 'font-weight:bold;' : ''}"/>
                                </g:column>
                                <g:column>
                                    <ui:define name="header">
                                        #{messages['net.ihe.gazelle.assertion-manager.Select']}
                                    </ui:define>
                                    <a4j:commandLink
                                            value="#{messages['net.ihe.gazelle.assertion-manager.Select']}"
                                            immdediate="true"
                                            actionListener="#{testStepLinkManager.setSelectedTest(test)}"
                                            render="testsForm,idSchemesForm,testStepsForm"/>
                                </g:column>
                                <f:facet name="footer">
                                    <ui:include src="/util/datatableFooter.xhtml">
                                        <ui:param name="dataScrollerId" value="TestStepIdTestsDs"/>
                                        <ui:param name="dataTableId" value="TestStepIdTests"/>
                                        <ui:param name="hideRowsSelect" value="true"/>
                                        <ui:param name="maxPages" value="5"/>
                                    </ui:include>
                                </f:facet>
                            </rich:dataTable>
                        </ui:decorate>
                        <h:panelGroup rendered="#{testStepLinkManager.isTestSelected()}">
                            <ui:decorate template="/layout/panels/_panel_title.xhtml">
                                <ui:define name="panel_title">
                                    #{messages['net.ihe.gazelle.assertion-manager.TestDescriptionOf']}
                                    #{testStepLinkManager.getSelectedTest().getKeyword()}
                                </ui:define>
                                <g:safehtml
                                        value="#{testStepLinkManager.getSelectedTestDescription()}"/>
                            </ui:decorate>
                        </h:panelGroup>
                    </h:form>
                </div>
                <div class="col-md-7">
                    <h:form id="testStepsForm">
                        <h:panelGroup rendered="#{testStepLinkManager.isTestSelected()}">
                            <ui:decorate template="/layout/panels/_panel_title.xhtml">
                                <ui:define name="panel_title">
                                    #{messages['net.ihe.gazelle.assertion-manager.TestSteps']}
                                </ui:define>
                                <rich:dataTable var="testStep" id="idTestSteps"
                                                value="#{testStepLinkManager.testSteps}" render="idTestStepsDs">
                                    <g:column>
                                        <ui:define name="header">
                                            #{messages['net.ihe.gazelle.assertion-manager.StepIndex']}
                                        </ui:define>
                                        <h:outputText value="#{testStep.stepIndex}"
                                                      style="#{testStepLinkManager.getSelectedTestStep().getStepIndex() == testStep.getStepIndex() ? 'font-weight:bold;' : ''}"/>
                                    </g:column>
                                    <g:column>
                                        <ui:define name="header">
                                            #{messages['net.ihe.gazelle.assertion-manager.TestRolesInitiator']}
                                        </ui:define>
                                        <h:outputText value="#{testStep.testRolesInitiator}"
                                                      style="#{testStepLinkManager.getSelectedTestStep().getStepIndex() == testStep.getStepIndex() ? 'font-weight:bold;' : ''}"/>
                                    </g:column>
                                    <g:column>
                                        <ui:define name="header">
                                            #{messages['net.ihe.gazelle.assertion-manager.TestRolesResponder']}
                                        </ui:define>
                                        <h:outputText value="#{testStep.testRolesResponder}"
                                                      style="#{testStepLinkManager.getSelectedTestStep().getStepIndex() == testStep.getStepIndex() ? 'font-weight:bold;' : ''}"/>
                                    </g:column>
                                    <g:column>
                                        <ui:define name="header">
                                            #{messages['net.ihe.gazelle.assertion-manager.Transaction']}
                                        </ui:define>
                                        <h:outputText value="#{testStep.transactionKeyword}"
                                                      style="#{testStepLinkManager.getSelectedTestStep().getStepIndex() == testStep.getStepIndex() ? 'font-weight:bold;' : ''}"/>
                                    </g:column>
                                    <g:column>
                                        <ui:define name="header">
                                            ##{messages['net.ihe.gazelle.assertion-manager.NbAssertions']}
                                        </ui:define>
                                        <h:outputText
                                                value="#{testStepLinkManager.getNbAssertionsOfTestStep(testStep.id)}"
                                                style="#{testStepLinkManager.getSelectedTestStep().getStepIndex() == testStep.getStepIndex() ? 'font-weight:bold;' : ''}"/>
                                    </g:column>
                                    <g:column>
                                        <ui:define name="header">
                                            #{messages['net.ihe.gazelle.assertion-manager.Select']}
                                        </ui:define>
                                        <a4j:commandLink
                                                value="#{messages['net.ihe.gazelle.assertion-manager.Select']}"
                                                immdediate="true"
                                                actionListener="#{testStepLinkManager.setSelectedTestStep(testStep)}"
                                                render="idSchemesForm,testStepsForm"/>
                                    </g:column>

                                    <f:facet name="footer">
                                        <ui:include src="/util/datatableFooter.xhtml">
                                            <ui:param name="dataScrollerId" value="idTestStepsDs"/>
                                            <ui:param name="dataTableId" value="idTestSteps"/>
                                            <ui:param name="hideRowsSelect" value="true"/>
                                            <ui:param name="maxPages" value="5"/>
                                        </ui:include>
                                    </f:facet>
                                </rich:dataTable>
                            </ui:decorate>
                            <h:panelGroup rendered="#{testStepLinkManager.isTestStepSelected()}">
                                <ui:decorate template="/layout/panels/_panel_title.xhtml">
                                    <ui:define name="panel_title">
                                        #{messages['net.ihe.gazelle.assertion-manager.TestStepIndex_2']}
                                        #{testStepLinkManager.selectedTestStep.stepIndex}
                                    </ui:define>
                                    <s:decorate template="/layout/display/_display.xhtml">
                                        <ui:define name="label">
                                            #{messages['net.ihe.gazelle.assertion-manager.TestStepIndex']}
                                        </ui:define>
                                        <h:outputText
                                                value="#{testStepLinkManager.selectedTestStep.stepIndex}"/>
                                    </s:decorate>
                                    <s:decorate template="/layout/display/_display.xhtml">
                                        <ui:define name="label">
                                            #{messages['net.ihe.gazelle.assertion-manager.TestRoleInitiator']}
                                        </ui:define>
                                        <h:outputText
                                                value="#{testStepLinkManager.selectedTestStep.testRolesInitiator}"/>
                                    </s:decorate>
                                    <s:decorate template="/layout/display/_display.xhtml">
                                        <ui:define name="label">
                                            #{messages['net.ihe.gazelle.assertion-manager.TestRoleResponder']}
                                        </ui:define>
                                        <h:outputText
                                                value="#{testStepLinkManager.selectedTestStep.testRolesResponder}"/>
                                    </s:decorate>
                                    <s:decorate template="/layout/display/_display.xhtml">
                                        <ui:define name="label">
                                            #{messages['net.ihe.gazelle.assertion-manager.Transaction']}
                                        </ui:define>
                                        <h:outputText
                                                value="#{testStepLinkManager.selectedTestStep.transactionKeyword}"/>
                                    </s:decorate>
                                    <s:decorate template="/layout/display/_display.xhtml">
                                        <ui:define name="label">
                                            #{messages['net.ihe.gazelle.assertion-manager.Description']}
                                        </ui:define>
                                        <h:outputText
                                                value="#{testStepLinkManager.selectedTestStep.description}"/>
                                    </s:decorate>

                                </ui:decorate>
                                <ui:decorate template="/layout/panels/_panel_title.xhtml">
                                    <ui:define name="panel_title">
                                        #{messages['net.ihe.gazelle.assertion-manager.ThisTestStep']}
                                        (#{testStepLinkManager.selectedTestStep.stepIndex})
                                        #{messages['net.ihe.gazelle.assertion-manager.IsLinkedToThoseAssertions']}
                                    </ui:define>
                                    <rich:dataTable rows="20" id="ruleCoverage"
                                                    var="assertionCoverage"
                                                    value="#{testStepLinkManager.assertionsOfSelectedTestStep()}">
                                        <g:column id="action">
                                            <a4j:commandButton styleClass="btn-sm gzl-btn-red"
                                                               rendered="#{testStepLinkManager.isSelectedTestStepLinkedTo(assertionCoverage.assertion.id)}"
                                                               actionListener="#{testStepLinkManager.unlinkSelectedTestStepFrom(assertionCoverage.assertion.id)}"
                                                               immdediate="true"
                                                               value="#{messages['net.ihe.gazelle.assertion-manager.Unlink']}"
                                                               render="action,ruleCoverage,idSchemesForm"/>
                                        </g:column>
                                        <g:column>
                                            <ui:define name="header">
                                                #{messages['net.ihe.gazelle.assertion-manager.SelectIdScheme']}
                                            </ui:define>
                                            <a4j:commandLink immdediate="true"
                                                             value="#{assertionCoverage.assertion.target.idScheme}"
                                                             actionListener="#{testStepLinkManager.setSelectedIdScheme(assertionCoverage.assertion.target.idScheme)}"
                                                             render="idSchemesForm,filterform"/>
                                        </g:column>
                                        <g:column>
                                            <ui:define name="header">
                                                #{messages['net.ihe.gazelle.assertion-manager.AssertionId']}
                                            </ui:define>
                                            <h:outputLink id="linkAssertion" target="_assertion"
                                                          title="#{messages['net.ihe.gazelle.assertion-manager.ViewAssertion']}"
                                                          value="#{request.contextPath}/assertions/show.seam">
                                                <f:param name="id" value="#{assertionCoverage.assertion.id}"/>
                                                <h:outputText
                                                        value="#{assertionCoverage.assertion.assertionId}"/>
                                            </h:outputLink>
                                        </g:column>
                                    </rich:dataTable>
                                </ui:decorate>
                            </h:panelGroup>
                        </h:panelGroup>
                    </h:form>
                </div>
            </ui:define>
            <ui:define name="assertionsLinking">
                <h:form id="idSchemesForm">
                    <ui:include src="../_linkAll.xhtml">
                        <ui:param name="manager" value="#{testStepLinkManager}"/>
                    </ui:include>
                    <rich:dataTable rows="20" id="TestStepsIdScheme" var="assertion"
                                    value="#{testStepLinkManager.assertions}" render="TestStepsIdSchemeDs">
                        <g:column id="action"
                                  rendered="#{testStepLinkManager.isTestStepSelected()}">
                            <a4j:commandButton styleClass="btn-sm gzl-btn-green"
                                               disabled="#{!testStepLinkManager.isTestStepSelected()}"
                                               rendered="#{not testStepLinkManager.isSelectedTestStepLinkedTo(assertion.id) }"
                                               actionListener="#{testStepLinkManager.linkSelectedTestStepTo(assertion.id)}"
                                               immdediate="true"
                                               value="#{messages['net.ihe.gazelle.assertion-manager.LinkTo']}"
                                               render="idSchemesForm,testStepsForm"/>
                            <a4j:commandButton styleClass="btn-sm gzl-btn-red"
                                               disabled="#{!testStepLinkManager.isTestStepSelected()}"
                                               rendered="#{testStepLinkManager.isSelectedTestStepLinkedTo(assertion.id)}"
                                               actionListener="#{testStepLinkManager.unlinkSelectedTestStepFrom(assertion.id)}"
                                               immdediate="true"
                                               value="#{messages['net.ihe.gazelle.assertion-manager.Unlink']}"
                                               render="idSchemesForm,testStepsForm"/>
                        </g:column>
                        <ui:include src="../_linkAssertionsTable.xhtml">
                            <ui:param name="assertionParam" value="#{assertion}"/>
                        </ui:include>
                        <f:facet name="footer">
                            <ui:include src="/util/datatableFooter.xhtml">
                                <ui:param name="dataScrollerId" value="TestStepsIdSchemeDs"/>
                                <ui:param name="dataTableId" value="TestStepsIdScheme"/>
                                <ui:param name="hideRowsSelect" value="true"/>
                                <ui:param name="maxPages" value="5"/>
                            </ui:include>
                        </f:facet>
                    </rich:dataTable>
                </h:form>
                <ui:include src="../_linkAllPopup.xhtml">
                    <ui:param name="manager" value="#{testStepLinkManager}"/>
                    <ui:param name="formToRender" value="testStepsForm"/>
                </ui:include>
            </ui:define>
        </ui:decorate>
    </ui:define>
</ui:composition>
